(function( tiQuery ) {
  var $        = tiQuery
  ,   root     = tiQuery.root
  ,   _        = $.globals._
  ,   console  = $.console

  // Bug: When creating many table rows, many callbacks will not be registered.
  // In particular, row 0 will register fine, row 1 will not.
  //
  // Note that this bug may only manifest itself on multi-core devices
  // iPhone simulator on dual-core Macbook Pro, iPad?
  //
  // on line 87, switch which implementation to use to see what works and doesn't.

  var tableView = $({
    type: 'tableView',
    id: 'tableView',
    height: '480',
    width: '320'
  })

  $(root).add(tableView)

  var rows = []

  // Doesn't work
  var addDebugItem = function ( title, callback ) {
    var row = $({
        type: 'tableRow',
        title: title
      })
    var rowFirst = row.first()
    rowFirst.addEventListener('click', callback)
    tableView.first().appendRow( rowFirst )
  }

  // Works
  var addDebugItem1 = function ( title, callback ) {
    var row = Ti.UI.createTableViewRow({
        title: title
      })
    row.addEventListener('click', callback)
    tableView.first().appendRow( row )
  }

  // Works
  var addDebugItem2 = function ( title, callback ) {
    var builder = Ti.UI.createTableViewRow
    var row = builder({
        title: title
      })
    row.addEventListener('click', callback)
    tableView.first().appendRow( row )
  }

  // Doesn't work
  var addDebugItem3 = function ( title, callback ) {
    console.log('Adding row ' + title)
    var builder = Ti.UI.createTableViewRow
    var row = builder({
      type: 'tableRow',
      title: title
    })

    row.addEventListener('click', callback)

    tableView.first().appendRow( row )
  }

  // Doesn't work
  var addDebugItem4 = function ( title, callback ) {
    console.log('Adding row ' + title)
    var builder = Ti.UI.createTableViewRow
    var row = builder({
      type: 'tableRow',
      title: title
    })

    var tiQueryRow = $(row)
    row.addEventListener('click', callback)

    tableView.first().appendRow( row )
  }

  // Works
  var addDebugItem5 = function ( title, callback ) {
    console.log('Adding row ' + title)
    var row = Ti.UI.createTableViewRow({
        title: title
      })
    row.addEventListener('click', callback)
    tableView.first().appendRow( row )
  }

  var clickCount = 0;
  var i;

  // If you reduce the count here to about 50, things will probably work
  for (i = 0; i < 100; i ++) {
    addDebugItem5( 'Row ' + i, function() {
      clickCount += 1
      console.log('Clicked ' + clickCount + ' times')
      var confirmDialog = Titanium.UI.createAlertDialog({
        title: 'Click handled!',
        message: 'Alert!',
        buttonNames: ['Huzzah']
      })
      confirmDialog.show()
    })
  }

  rows.forEach( function( row ) {
    row.fireEvent('click')
  })
})( tiQuery )